--- a/drivers/net/wireless/ath/ath.h
+++ b/drivers/net/wireless/ath/ath.h
@@ -83,6 +83,7 @@ struct ath_regulatory {
 	u16 max_power_level;
 	u16 current_rd;
 	int16_t power_limit;
+	int16_t max_antenna_gain;
 	struct reg_dmn_pair_mapping *regpair;
 };
 
--- a/drivers/net/wireless/ath/ath9k/hw.c
+++ b/drivers/net/wireless/ath/ath9k/hw.c
@@ -2711,7 +2711,7 @@ void ath9k_hw_apply_txpower(struct ath_h
 	channel = chan->chan;
 	chan_pwr = min_t(int, channel->max_power * 2, MAX_RATE_POWER);
 	new_pwr = min_t(int, chan_pwr, reg->power_limit);
-	max_gain = chan_pwr - new_pwr + channel->max_antenna_gain * 2;
+	max_gain = chan_pwr - new_pwr + reg->max_antenna_gain * 2;
 
 	ant_gain = get_antenna_gain(ah, chan);
 	if (ant_gain > max_gain)
--- a/drivers/net/wireless/ath/ath9k/main.c
+++ b/drivers/net/wireless/ath/ath9k/main.c
@@ -1405,7 +1405,10 @@ static int ath9k_config(struct ieee80211
 	}
 
 	if (changed & IEEE80211_CONF_CHANGE_POWER) {
+		struct ath_regulatory *reg = ath9k_hw_regulatory(ah);
+
 		ath_dbg(common, CONFIG, "Set power: %d\n", conf->power_level);
+		reg->max_antenna_gain = conf->max_antenna_gain;
 		sc->config.txpowlimit = 2 * conf->power_level;
 		ath9k_cmn_update_txpow(ah, sc->curtxpow,
 				       sc->config.txpowlimit, &sc->curtxpow);
